/***
   This file is part of the Tesseract plugin for fly-ocr.

   Copyright (C) 2021 LLC "RusBITech-Astra" (https://astralinux.ru)

   Foobar is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   Foobar is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with the Tesseract plugin for fly-ocr. If not, see
   <https://www.gnu.org/licenses/>.
***/

#ifndef TESSERACTFACTORY_H
#define TESSERACTFACTORY_H

#include <QObject>
#include <fly-ocr/ocrenginefactory.h>

class TesseractFactory : public QObject, OcrEngineFactory
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "ru.astralinux.fly-ocr.OcrEngineFactoryInterface.1.0")
    Q_INTERFACES(OcrEngineFactory)

public:
    QString name() const override;
    QString shortName() const override;
    QString version() const override;
    QList<FlyOcr::Lang> languages() const override;
    QList<PageSegmentationMode> pageSegmentationModes() const override;
    QStringList defaultLanguages() const override;
    int defaultPageSegmentationModeId() const override;
    OcrEngine* create(QObject* parent) override;
    Formats supportedPageDataFormats() const override;
    Formats supportedExportFormats() const override;
    QList<QAction*> createActions(QWidget* parent) override;
    QString about() const override;
};

#endif
